//
//  MongoIncludes.h
//  LibSkynet
//
//  Created by Miha Nedok
//  Copyright © 2018 Mike. All rights reserved.
//

#ifndef MongoIncludes_h
#define MongoIncludes_h


#include <cstdlib>
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <exception>
#include <ostream>
#include <sstream>
#include <thread>
#include <iterator>
#include <vector>


#include <bsoncxx/array/view.hpp>

#include <bsoncxx/document/value.hpp>
#include <bsoncxx/document/view.hpp>


#include <bsoncxx/builder/basic/document.hpp>
#include <bsoncxx/builder/basic/kvp.hpp>
#include <bsoncxx/builder/basic/array.hpp>
#include <bsoncxx/builder/stream/array.hpp>
#include <bsoncxx/builder/stream/document.hpp>


#include <bsoncxx/stdx/string_view.hpp>
#include <bsoncxx/string/to_string.hpp>

#include <bsoncxx/json.hpp>
#include <bsoncxx/types.hpp>


#include <mongocxx/instance.hpp>
#include <mongocxx/pool.hpp>
#include <mongocxx/uri.hpp>
#include <mongocxx/client.hpp>
#include <mongocxx/stdx.hpp>

using bsoncxx::builder::stream::close_array;
using bsoncxx::builder::stream::close_document;
using bsoncxx::builder::stream::document;
using bsoncxx::builder::stream::finalize;
using bsoncxx::builder::stream::open_array;
using bsoncxx::builder::stream::close_array;
using bsoncxx::builder::stream::open_document;
using bsoncxx::builder::basic::kvp;
using bsoncxx::builder::basic::make_document;
using bsoncxx::builder::concatenate;

using bsoncxx::stdx::string_view;


using dbdocument = bsoncxx::stdx::optional<bsoncxx::document::value>;
using belement   = bsoncxx::document::element;

using bdocvalue  = bsoncxx::document::value;
// Basic Builder
using bbuilder   = bsoncxx::builder::basic::document;




#define BELEMENTSTRING(element)    element.get_utf8().value.to_string()
#define BELEMENTCCHAR(element)     element.get_utf8().value.to_string().c_str()
#define BE_STR(element)            element.get_utf8().value.to_string()
#define BE_BOOL(element)           element.get_bool()
#define BE_OID(element)            element.get_oid()
#define BE_BINARY(element)         element.get_binary()
#define BE_DOCUMENT(element)       element.get_document()
#define BE_ARRAY(element)          element.get_array()
#define BE_DATE(element)           element.get_date()
#define BE_DOUBLE(element)         element.get_double()
#define BE_TIMESTAMP(element)      element.get_timestamp()
#define BE_INT32(element)          element.get_int32()


#define BE_IS_STRING(element) element.type() == bsoncxx::types::b_utf8::type_id
#define BE_IS_NULL(element)   element.type() == bsoncxx::types::b_null::type_id
#define BE_IS_BOOL(element)   element.type() == bsoncxx::types::b_bool::type_id
#define BE_IS_INT32(element)  element.type() == bsoncxx::types::b_int32::type_id
#define BE_IS_BINARY(element) element.type() == bsoncxx::types::b_binary::type_id
#define BE_IS_DOUBLE(element) element.type() == bsoncxx::types::b_double::type_id


// check if val exists before calling append on bb
#define BB_APPEND_VAL(bb,key,val) if (val){bb.append(kvp(key,val));}

#define MONGODB_APPID(appId)     AppEntry *appEntry = globalManager->applicationEntry(appId); \
                                 mongocxx::pool::entry client = appEntry->mongoPool->acquire();\
                                 mongocxx::database    db   = (*client)[appEntry->mongoDb]

#define MONGODB_GM_APPID(gm,appId) AppEntry *appEntry = gm->applicationEntry(appId); \
                                   mongocxx::pool::entry client = appEntry->mongoPool->acquire();\
                                   mongocxx::database    db   = (*client)[appEntry->mongoDb]


using namespace mongocxx;

#endif /* MongoIncludes_h */
